% Program for solving (5.8) for the case on a binomial arrival distribution. 
%The inputs are: the number of independent sources, n, the probability of a
%source being active, p and b, the size of the buffer. 
%The output is: 1) Probability of an empty buffer 2) Average number of messages in the buffer
% 3) Message loss rate 4) Average message delay

function y=ex53(n,q,b)

% First generate the arrival probabilities
for i=1:n+1
    a(i)=comb(n,i-1)*q^(i-1)*(1-q)^(n-i+1);
end

%Check: All of the rows of the transition matrixThe terms on the arrival
%distribution should sum to one.
sum=0;
for j=1:n+1
sum=sum+a(j);
end
   
    
% The next step is to find the buffer occupancy probabilities from equation (5.8).We take care that
%the dimensions of the input array are not exceeded.

p(1)=1;%intialization
for i=1:b
    sum=0;
    for k=2:i
        if i-k+2 > n
            arr=0;
        else arr=a(i-k+2);
        end
        sum=sum+p(k)*arr;
    end
    if i > n
        arr=0;
    else arr=a(i);
    end
    p(i+1)=(p(i)-sum-p(1)*arr)/a(1);
end   
%The next step is to normalize the terms of p(.) as in equation (5.9).
norm=0;
for i=1:b+1
    norm=norm+p(i);
end
for i=1:b+1
    p(i)=p(i)/norm;
end

 
% The array p gives the buffer occupancy probabilities.
y(1)=p(1); %Probability of an empty buffer

% Now, find the average buffer occupancy
average=0;
for i=1:b+1;
   average=average+(i-1)*p(i);
end
y(2)=average;% Average buffer occupancy

% Calculation for average loss rate
avearrive=0;
for i=1:n+1
   avearrive=avearrive+(i-1)*a(i);
end
y(3)=1-(1-y(1))/avearrive;%Average loss rate.

% Finally, average delay of a packet in units of slot times.
y(4)=y(2)/(1-y(1));

Return
