%Following example 5.5, we solve (5.37) for the probabilities of
%buffer occupancy and the average nnumber of packets in the buffer.
function pr=ex55(lT)
b=4;
P=.2;
%The first step is to calculate the matrix. 
x=roots(lT);%Roots of the denominator in equation (5.25).
for i=1:b
   DELTA(i,1)=b+1-i;
   for j=2:b
      DELTA(i,j) = x(j)^b-x(j)^(i-1);
   end
end
%Now, we find the vector A.

A(1)=b-lT/(1-P);
for i=2:b
   A(i)=0;
end
pr=A*inv(DELTA);

%The final step is to find the average number of packets 
%in the buffer from equation (5.39)

rho=lT/(1-P);
Mpp=2*P/(1-P)^2;
term=0;

for j=1:b
   term=term + pr(j)*(b*(b-1)-j*(j-1)+2*rho*(b-j));
end

pr(b+1)=(term-b*(b-1)+lT*Mpp+rho^2)/(2*(b-rho));

pr = real(pr(1:b));
      