function chekwbar=ex77()
format long e;
% we have to choose average arrival rate, xicov, beta which we choose using H....
wbar = 5.5                 
xicov = 2                   
d = 4                         
H = 0.75                   
N(1) = 3;
N(2) = 4;
N(3) = 2;
N(4) = 3;
% We need to choose the tau values here... If we choose tau-1, that is enough. We choose b.
tau(1) = 2;
betal = 2 - (2*H)
b = 3
%Now we are calculating other tau's....
for i = 2:d
tau(i) = 10^(i-1)*tau(1);
end
% we initialize lambda(d) and Kay(d) and then proceed to recursively calculate other lambda's and Kay's
% The expression used is based on the notation used in Exercise 7.3
lambda(d) = ( (betal*log(b))/((b-1)*tau(d)) )
kay(d) = (xicov*tau(d)^(-betal))/exp(-lambda(d)*tau(d))
for j = (d-1):-1:1
   fp = 0;
   ep = 0;
   for l = (j+1):d
       fp = fp + (kay(l)*exp(-(lambda(l)*tau(j))));
      ep = ep + (kay(l)*exp(-(lambda(l)*b*tau(j))));
  end
  cp = fp - (b^(-betal)*ep)
  gp = xicov*(tau(j)^(-betal))
  lambda(j) = ((-1)/(tau(j)*(b-1)))*log(b^(-betal)-(cp/(gp-ep)))
  kay(j) = cp/((b^(-betal)*exp(-(lambda(j)*tau(j))))-exp(-(lambda(j)*b*tau(j))))
end
% Here, we are solving for alpha using Newton's method....
alphaiter =0.05*lambda(1)
   falpha = 0;
   fpalpha = 0;
   for i = 1:d
       temp1 = sqrt(kay(i)*N(i)*alphaiter);
       temp2 = (10^(i-1)*lambda(i))-alphaiter;
       falpha = falpha + (temp1/sqrt(temp2));
       fpalpha = fpalpha + ( (0.5*10^(i-1)*lambda(i))/(temp1*temp2^(1.5)) );
   end
   falpha = falpha - wbar;
   alphaiter1 = alphaiter - (falpha/fpalpha);
% This program will prematurely terminate if the quantities become negative resulting complex numbers %when square root operation is performed...... Note that fpalpha is obtained by differentiating Equation %(7.69) with respect to alpha1 
while abs(alphaiter - alphaiter1) > 10^(-19)
   falpha = 0;
   fpalpha = 0;
   alphaiter = alphaiter1;
   for i = 1:d
       temp1 = sqrt(kay(i)*N(i)*alphaiter);
       temp2 = (10^(i-1)*lambda(i))-alphaiter;
       if temp2 <0
         break
       end
       falpha = falpha + (temp1/sqrt(temp2));
       fpalpha = fpalpha + ( (0.5*10^(i-1)*lambda(i))/(temp1*temp2^(1.5)) );
   end
   falpha = falpha - wbar;
   alphaiter1 = alphaiter - (falpha/fpalpha);
   if alphaiter < 0
      break
   end
end
% At this point we have got alpha(1) so, we can use it to calculate other alpha's, beta's and rate's...
alpha(1) = alphaiter
for i =2:d
 alpha(i) = 10^(1-i)*alpha(1)
 beta(i) = lambda(i) - alpha(i)
 rate(i) = sqrt((kay(i)*lambda(i)^2)/(N(i)*alpha(i)*beta(i)))
end
beta(1) = lambda(1) - alpha(1)
rate(1) = sqrt((kay(1)*lambda(1)^2)/(N(1)*alpha(1)*beta(1)))
%Here we are checking to see whether the net average bit rate is what we initially started with....
chekwbar = 0;
for i=1:d
chekwbar = chekwbar + ((N(i)*rate(i)*alpha(i))/(alpha(i)+beta(i)));
end
chekwbar

