%In this we calculate the parameters as described in Example 8.12
%We have input parameters as explained in the text
%Typical values are lambdastar = 8, n=8,d=6,corrlagone=0.5, H=0.75,q(1)=0.8
function [lambdaIPP,r1,r2]=ex812(lambdastar,n,d,corrlagone,H,q1)
format long e;
%lambdastar = 8       
%n = 8               
%d = 6                 
%corrlagone = 0.5    
%H = 0.75         
%q(1) = 0.8
q(1)=q1;
dstar = d;
beta = 2 - (2*H);
dp = d;
while (i < 100)
   [phi, d, a] = phievaluate(n,d,beta,dstar);
   if d == 0
      dp = dp + 1;
      d = dp;
   else
      break;
   end
end
for i = 2:d
   q(i) = a^(1-i)*q(1);
end
 % we cannot allow this happen so, we need to adjust the parameters
    if (q(1) > 1)
        q(1) = 0.7; % making an arbitrary setting... the user can set this to any default value
    end
    if (corrlagone > 0.5)
        corrlagone = 0.4;  % again the same idea here too
   end
tmpvar = 0;
for i = 1:d
  tmpvar = tmpvar + ((phi(i)^2)*q(i)^(-2)*((1-exp(-q(i)))^2-(2*corrlagone*(q(i)-(1-exp(-q(i))) ) ) ) );
end
mu = sqrt(4*corrlagone*lambdastar)/sqrt(tmpvar);
L1 = mu * (sum(phi)/2);
if lambdastar > L1
     lambdaP = lambdastar - L1;
     for i = 1:d
        r1(i) = 0.5 * q(i);
        r2(i) = r1(i);
        lambdaIPP(i) = mu * phi(i);
    end
else
    lambdaP = 0;
    for i = 1:d
       r1(i) = L1^2/(L1^2+lambdastar^2)*q(i);
       r2(i) = q(i) - r1(i);
       lambdaIPP(i) = phi(i) * (lambdastar^2 + L1^2)/(lambdastar * sum(phi));
   end
end
check = 0;
for i = 1 : d
check = check + ((r2(i)/(r1(i)+r2(i)))*lambdaIPP(i));
end
check1 = check + lambdaP;  
return



