%In this program we carry out the calculations for example 8.2, which is for the MMPP case. 
% The inputs are: 
% R a (LxL) matrix, element r(i,j)= tranition rate from i to j 
% LMBD a a L dimansional vector giving the rates for each phase.

function ave=ex82(R,LMBD)
L=size(R,1);%The number of phases
%The first step is to find the matrix D, as in equation (8.8).

%We fetch D0 and D1 from ex81
fetch=ex81(R,LMBD)
D0=fetch(:,:,1)
D1=fetch(:,:,2)
D=D0+D1

%Now, we solve (8.9). The solution is the eigenvector corresponding to the
%zero eigenvalue of the matrix D'.
[V,EV]=eig(D');%V is the matrix of eigenvectors.
x=abs(V(:,1));%The first column of V is the "zero"eigenvector. All elements should have the same sign.

%The last step in solving (8.3) is normalizing so the the sum of the elements is one.
pi=x'/sum(x) %These are the phase probabilities.

%Finally, we do the calculation in (8.10).

ave=pi*D1*ones(L,1);% This is (8.10) in the MMPP case. The term "ones(L,1)" is the column vector of L ones.