%In this program we carry out the calculations for example 8.3, which is for the BMAP case. 
% The inputs are: 
% R a (LxL) matrix, element r(i,j)= tranition rate from i to j 
% LMBD a a L dimansional vector giving the rates for each phase.
% A an (NxN) matrix giving the batch arrival distribution for each phase.

function ave=ex83(R,LMBD,A)
L=size(R,1);%The number of phases
%The first step is to find the matrix D, as in equation (8.8).
D=R;%Initialization

for i = 1:L
    D(i,i)=-sum(R(i,:));%The diagonal elements are to sums of off diagonal elements;
end

%Now, we solve (8.9). The solution is the eigenvector corresponding to the
%zero eigenvalue of the matrix D'.
[V,E]=eig(D');%V is the matrix of eigenvectors.
x=abs(V(:,1));%The first column of V is the "zero"eigenvector. All elements should have the same sign.

%The last step in solving (8.3) is normalizing so the the sum of the elements is one.
pi=x'/sum(x);%These are the phase probabilities.

%Finally, we do the calculation in (8.10).

N=size(A,1);
D1=zeros(L);
for j=1:L
    D1(j,j)=LMBD(1)*A(1,j);
end

D2=zeros(L);
for j=1:L
    D2(j,j)=LMBD(2)*A(2,j);
end


ave=pi*(D1+2*D2)*ones(L,1);% This is (8.10) in the BMAP case. The term "ones(L,1)" is the column vector of L ones.