%A chi-square test is carried out to test samples drawn from a Rayleigh distribution 
%for conformity to an exponetial distribution distribution. 

function [tailprob]=ex915(numclls, smplsz)

rand('state',0)%initializing the random number generator

%The first step is to generate the Rayleigh samples with the idea of 
%estimating the mean.
for i=1:smplsz;
   r(i)=sqrt(-(16/pi)*log(rand));%generating Rayleigh random variables with mean 2.
end
smpmn=mean(r);%sample mean
lambda=1/smpmn;
%This is used for the exponential distribution below, where we compare the Rayleigh 
%distruted variables just generated with a exponential distribution with mean 1/lambda.


%We do the comparison over an interval that is five time the mean,i.e.
%5/lambda.

cellsz=(5/lambda)/numclls;%Cell width.

%Next, we generate the probability of an exponetiially distributed random
%variable falling into the cell.
for i=1:numclls-1
    midcell=cellsz*(i-1/2);
    p(i)=lambda*exp(-lambda*midcell)*cellsz;
end
p(numclls)=exp(-5);%This is area in the tail beyond five times the mean.

check=sum(p)


%The next step is to count the number of samples in 
%each cell.the vector n gives the count.
n=zeros(1,numclls);%Initialization. The vector n give the numbers of samples are in each cell.
for i=1:smplsz
    for j=1:numclls
  
        if r(i)<j*cellsz 
        n(j)=n(j)+1;
        end
 
        if r(i)>=5/lambda
        n(numclls)=n(numclls+1)+1;%This is the 'tail' cell.
        end
    end
end
cum=n(1);%The above gives the accumulation numbers. Now, we find the number in each cell.
for i=1:numclls-1
    n(i+1)=n(i+1)-cum;
    cum=cum+n(i+1);
end

%Now, the chi-square statistic is calculated
timeone=0;
chisq=0;
for i=1:numclls
  chisq=chisq+(smplsz*p(i)-n(i))^2/(smplsz*p(i));
end
x=chisq
tailprob=chitail(numclls-1,chisq)

