%A chi-square test is carried out to test samples 
%for conformity to a Poisson arrival process. 

function [tailprob]=ex916(numclls, smplsz, inter)
%Numclls is the number of cell that the interval is divided into.
%smplsz is the number of arrivals. Recall the simplifying assumption that
%this is an odd number.
%inter is the duration of the interval.

rand('state',123)%initializing the random number generator

%The first step is to generate the samples uniformly distributed over an interval. Normally, these would
%be given as a set of data.
r=ex914(smplsz,inter);%This generates the arrivals uniformly distributed over inter.

p=ones(1,numclls)/numclls;%This simply gives a discrete uniform distribution over the numclls. 

cellsz=inter/numclls;

%The next step is to count the number of samples in 
%each cell.the vector n gives the count.
n=zeros(1,numclls);%Initialization. The vector n give the numbers of samples are in each cell.
for i=1:smplsz
    for j=1:numclls
  
        if r(i)<j*cellsz 
        n(j)=n(j)+1;
        end
    end
end
cum=n(1);%The above gives the accumulation numbers. Now, we find the number in each cell.
for i=1:numclls-1
    n(i+1)=n(i+1)-cum;
    cum=cum+n(i+1);
end

%Now, the chi-square statistic is calculated
timeone=0;
chisq=0;
for i=1:numclls
  chisq=chisq+(smplsz*p(i)-n(i))^2/(smplsz*p(i));
end
x=chisq
tailprob=chitail(numclls-1,chisq)

