%This program is a time driven simulation of the  the M/M/1 queue. The 
%inputs are the average message length and 
%the time duration of the simulation. The output is an estimate of the
%average delay.

function [ans]=ex917(mess,time);
rand('state',314)%initializing the random number generator

maxlmdba=1/mess;%This is the maximum message arrival rate for the system to be stable.

for k=2:20%We increment the load. For each value we run the simulation and measure average delay.
    load = (k-1)/20;
    lmbda=load/mess;
    %initializing
currtime=0;%clock value
queue=[0];%vector for messages in buffer
numarr=0;%total number of arrivals
sample=0;%running variable indicating the number of delay samples
mu=1/mess;%message departure rate
clckstp=.01/maxlmdba;%incremental interval
currtime=clckstp;
while currtime < time
   if rand < lmbda*clckstp%testing for message arrival
      queue(1)=queue(1)+1;%The first element of the queue vector indicates the number in the queue.
      numarr=numarr+1;
      queue(queue(1)+1)=currtime;%time of new arrival
      
   end
   if rand < mu*clckstp & queue(1)>0 %testing for message departure
      sample=sample+1;
      delay(sample)=currtime-queue(2);%delay sample
      queue(1)=queue(1)-1;%updating the queue in terms of the number in the queue.
      
      if queue(1)>0
         queue=[queue(1),queue(3:end)];%The message in queue(2) has been sent; so the queue is updated
      else
         queue=[0];%empty buffer
      end
      
   end
   currtime=currtime+clckstp;%incrementing the clock
end

avdelay(k)=mean(delay);%average delay

nosamples=sample;
end

ans=avdelay;
