%This program is an event driven simulation of the  the M/M/1 queue. The 
%inputs are the message arrival rate,the average message length and 
%the time duration of the simulation. The output is an estimate of the 
%delay distribution. It is assumed that messages are served in order of arrival.

function [d]= ex918(lmda,mess,time)
%rand('state',123);
%initializing the program
currtime=0;%clock value
queue=[0];%vector for messages in buffer
numarr=0;%running variable indicating the number of arrivals
numdep=0;%running variable indicating the number of departures
max =1000;%Upper bound on the number of arriavls in a message transmission.
while currtime < time
   
%first check if queue is empty
   if queue(1)<1; %empty queue
      currtime=currtime -((1/lmda)*log(rand)); %jumping to time of next arrival
      queue(1)=1;                                            %incrementing the queue
      queue(2)=currtime;                                %arrival time of message to an empty queue     
      numarr=numarr+1;
   end
%At this point, there should be at least one message in the queue.   

%next transmit a message
   service=-(mess*log(rand));    %exponential service time of the next message
   currtime=currtime+service;   %time jump to message departure
   newdelay=[currtime-queue(2)] ;
   numdep=numdep+1;
   delay(numdep)=newdelay; %building the delay vector
   queue(1)=queue(1)-1; %accounting for the departure
   queue=[queue(1) queue(3:end)]; %accounting for the departure
   
   %Now we generate the number of arrivals while the message was being
   %transmitted. See equation (9.30) of the text.
   prod=rand;
   thresh=exp(-lmda*service);
  if prod > thresh
   ind=0;   %initializing       
   while thresh < prod  %stepping through the distribution
      ind=ind+1;
      prod=prod*rand;
   end
   %'ind' is the number of Poisson arrivals in the interval.
   
   newarr=ex914(ind,service)+currtime-service;    %Updating the arrival times. This is a vector 
   %giving the arrival times of message that arrived during a service time.

   queue(1)=queue(1)+ind;    %Updating the queue with number of arrivals.
   
   queue=[queue newarr(1:end)];        %Splicing new arrival times onto the queue 
 end
end 
%numdep is the number of messages that have departed. A check is numarr=numde+queue(1)
%delay is a vector containing all of the departures. 
d = delay;
%d=mean(delay)%mean value of the delay samples
%dvar=var(delay);%variance of the delay
