%This program is a time driven simulation of the  the M/M/1 queue. The 
%inputs are the message arrival rate,the average message length and 
%the time duration of the simulation. The output is an estimate of the 
%delay distribution. It is assumed that messages are served in order of arrival.

function [delay]= mm1e(lmda,mess,time)
rand('state',0)
%initializing the program
currtime=0;%clock value
queue=[0];%vector for messages in buffer
numarr=0;%running variable indicating the number of arrivals
numdep=0;%running variable indicating the number of departures

while currtime < time
   
%first check if queue is empty
	if queue(1)<1; %empty queue
      currtime=currtime -(1/lmda)*log(rand);%jumping to time of next arrival
      queue(1)=1;%incrementing the queue
      queue(2)=currtime;%arrival time of message to an empty queue     
      numarr=numarr+1;
   end
%At this point, there should be at least one message in the queue.   

%next transmit a message
   service=-mess*log(rand);%exponential service time of the next message
   currtime=currtime+service;%time jump to message departure
   newdelay=[currtime-queue(2)]; 
   numdep=numdep+1;
   delay(numdep)=newdelay;%building the delay vector
   queue(1)=queue(1)-1;%accounting for the departure
   queue=[queue(1),queue(3:end)];%accounting for the departure
   newarr=genpoiss(lmda,currtime-service,currtime);%updating the arrival times
   %genpoiss is a vector, genpoiss(1) is the number of new arrivals in a service time
   %the remaining elements are the arrival times
   queue(1)=queue(1)+newarr(1);%updating the number of arrivals
   numarr=numarr+newarr(1);
   queue=[queue,newarr(2:end)];%splicing new arrivals onto the queue 
 
end 
%numdep is the number of messages that have departed. A check is numarr=numde+queue(1)
%delay is a vector containing all of the departures. 

d=mean(delay);%mean value of the delay samples
dvar=var(delay);%variance of the delay
