%This program is a time driven simulation of the  the M/M/1 queue. The 
%inputs are the message arrival rate,the average message length and 
%the time duration of the simulation. The output is an estimate of the 
%delay distribution.
function [delay]= mm1t(lmda,mess,time)
rand('state',0)%initializing the random number generator
%initializing
currtime=0;%clock value
queue=[0];%vector for messages in buffer
numarr=0;%total number of arrivals
sample=0;%running variable indicating the number of delay samples
mu=1/mess;%message departure rate
clckstp=.01/lmda;%incremental interval
currtime=clckstp;
while currtime < time
   if rand < lmda*clckstp%testing for message arrival
      queue(1)=queue(1)+1;
      numarr=numarr+1;
      queue(queue(1)+1)=currtime;%time of new arrival
      
   end
   if rand < mu*clckstp & queue(1)>0 %testing for message departure
      sample=sample+1;
      delay(sample)=currtime-queue(2);%delay sample
      queue(1)=queue(1)-1;%updating the queue
      
      if queue(1)>0
         queue=[queue(1),queue(3:end)];%the message in queue(2) has been sent
      else
         queue=[0];%empty buffer
      end
      
   end
   currtime=currtime+clckstp;%incrementing the clock
end
total=length(delay)%a count of the number of samples